package Log;
use strict;
use Option;

my $file_name = "";

#--------------------
sub new{
	my($proto, %args) = @_;
	my $class = ref($proto) || $proto;
	my $this  = {};
	$this->{opt} = undef;
	my $this  = {};
	bless($this, $class);

	$this->{opt} = new Option();

	return $this;
}

#--------------------
sub start{
	-d "./log" or mkdir "./log";

	$file_name = get_new_log_file_name();
}

#--------------------
sub write{
	my $this = shift;
	my $line = shift;

	$line = sprintf "[%s] %s", get_log_time(), $line;
	open(FH, ">>$file_name");
	print FH $line;
	close(FH);
}

#--------------------
sub get_new_log_file_name{
	my($sec, $min, $hour, $mday, $mon, $year) = localtime(time);
	return sprintf("./log/%04d-%02d-%02d+%02d-%02d-%02d.txt"
	, $year + 1900, $mon + 1, $mday, $hour, $min, $sec);
}

#--------------------
sub get_log_time{
	my($sec, $min, $hour, $mday, $mon, $year) = localtime(time);
	return sprintf("%02d-%02d %02d:%02d:%02d"
	, $mon + 1, $mday, $hour, $min, $sec);
}

#--------------------
1;
