#!/usr/bin/perl
use strict;

#--------------------
#main
package Msg;
use strict;
use Option;

#--------------------
sub new{
	my($proto, %args) = @_;
	my $class = ref($proto) || $proto;
	my $this  = {};
	$this->{opt} = undef;
	bless($this, $class);

	foreach(keys %args){
		$this->{$_} = $args{$_};
	}

	$this->{opt} = new Option();

	return $this;
}

#--------------------
sub line{
	my $this = shift;

	return "--------------------------------------------------------------------------------";
}

#--------------------
sub welcome{
	my $this = shift;

	my $line = "";

	if($this->{opt}->lang eq "en"){
		$line = qq(
--------------------------------------------------------------------------------
Welcome!!

This is welcome message from #p_name

We hope you to enjoy some chatting.
--------------------------------------------------------------------------------);
	}
	elsif($this->{opt}->lang eq "ko"){
		$line = qq(
--------------------------------------------------------------------------------
ȯմϴ!!

#server_name   ȯմϴ.

ſ ȭ  Ǳ⸦ ٶϴ.
--------------------------------------------------------------------------------);
	}

	my $server_name = $this->{opt}->server_name;
	$line =~ s/#server_name/$server_name/;
	$line =~ s/^\s+|\s+$//g;
	return $line;
}

#--------------------
sub lob_exit{
	my $this = shift;

	my $line = "";

	if($this->{opt}->lang eq "en"){
		return "\n-> Good bye~";
	}
	elsif($this->{opt}->lang eq "ko"){
		return "\n-> Good bye~";
	}

	return $line;
}

#--------------------
sub room_info{
	my $this = shift;
	my $r = shift;
	my $g_list = shift;

	my $r_owner_name = $r->owner->name;
	my $r_no = $r->no;
	my $r_subj = $r->subj;
	my $r_type = $r->pw ? $this->list_info("private") : $this->list_info("public");
	my $r_limit = $r->limit;

	my $line = "";

	if($this->{opt}->lang eq "en"){
		$line = qq(
Total number of guest: #total
--------------------------------------------------------------------------------
Room owner => #r_owner_name
Room no => #r_no
Room subject => #r_subj
Room type => #r_type
Room limit => #r_limit

#g_list
--------------------------------------------------------------------------------);
	}
	elsif($this->{opt}->lang eq "ko"){
		$line = qq(
: #total
--------------------------------------------------------------------------------
 => #r_owner_name
ȣ => #r_no
 => #r_subj
 => #r_type
ο => #r_limit

#g_list
--------------------------------------------------------------------------------);
	}

	$line =~ s/#r_owner_name/$r_owner_name/;
	$line =~ s/#r_no/$r_no/;
	$line =~ s/#r_subj/$r_subj/;
	$line =~ s/#r_type/$r_type/;
	$line =~ s/#r_limit/$r_limit/;
	$line =~ s/#g_list/$g_list/;
	return $line;
}

#--------------------
sub already_public{
	my $this = shift;


	if($this->{opt}->lang eq "en"){
		return "\n-> This is already a public room";
	}
	elsif($this->{opt}->lang eq "ko"){
		return "\n->  ȭ ̹  ȭԴϴ.";
	}
}

#--------------------
sub name_req{
	my $this = shift;

	if($this->{opt}->lang eq "en"){
		return "\n-> Please input your name.";
	}
	elsif($this->{opt}->lang eq "ko"){
		return "\n-> ȭ Է ּ.";
	}
}

#--------------------
sub name_chg{
	my $this = shift;
	my $line = shift;

	if($this->{opt}->lang eq "en"){
		return sprintf "\n-> Your name has been set to %s", $line;
	}
	elsif($this->{opt}->lang eq "ko"){
		return sprintf "\n-> ȭ %s Ǿϴ.", $line;
	}
}

#--------------------
sub subj_chg{
	my $this = shift;
	my $line = shift;

	my $res = "";
	if($this->{opt}->lang eq "en"){
		$res = sprintf "\n-> Room subject has been changed as following.";
		$res .= sprintf "\n-> %s", $line;
	}
	elsif($this->{opt}->lang eq "ko"){
		$res = sprintf "\n-> ȭ    Ǿϴ.";
		$res .= sprintf "\n-> %s", $line;
	}

}

#--------------------
sub limit_chg{
	my $this = shift;
	my $line = shift;

	if($this->{opt}->lang eq "en"){
		return sprintf "\n-> Guest limit of the room has been changed to %s", $line;
	}
	elsif($this->{opt}->lang eq "ko"){
		return sprintf "\n-> ȭ ο %s Ǿϴ.", $line;
	}
}

#--------------------
sub name_none{
	my $this = shift;

	if($this->{opt}->lang eq "en"){
		return "\n-> No space and no special character allowed.";
	}
	elsif($this->{opt}->lang eq "ko"){
		return "\n-> ȭ Ưڳ    ϴ.";
	}
}

#--------------------
sub name_len{
	my $this = shift;

	if($this->{opt}->lang eq "en"){
		return "\n-> Name length must be between 4 ~ 12 byte.";
	}
	elsif($this->{opt}->lang eq "ko"){
		return "\n-> ȭ ̴  4 ~ 12, ѱ 2 ~ 6  ˴ϴ.";
	}
}

#--------------------
sub name_same{
	my $this = shift;
	my $name = shift;

	my $line = "";
	if($this->{opt}->lang eq "en"){
		$line = qq(
-> Although you requested your name set to #name
-> But there is already a guest who has the same name as yours.);
	}
	elsif($this->{opt}->lang eq "ko"){
		$line = "->  ̸ ȭ ̹ մϴ.";
	}

	$line =~ s/#name/$name/;
	return $line;
}

#--------------------
sub cmd_can{
	my $this = shift;
	my $cmd = shift;

	if($this->{opt}->lang eq "en"){
		return sprintf "\n-> Command '%s' canceled.", $cmd;
	}
	elsif($this->{opt}->lang eq "ko"){
		return sprintf "\n-> ɾ '%s' ҵǾϴ.", $cmd;
	}
}

#--------------------
sub cancel{
	my $this = shift;

	if($this->{opt}->lang eq "en"){
		return "-> (0 = Cancel).";
	}
	elsif($this->{opt}->lang eq "ko"){
		return "-> (0 = ).";
	}
}

#--------------------
sub yes_no_cancel{
	my $this = shift;

	if($this->{opt}->lang eq "en"){
		return"-> (Y = Yes, N = No, 0 = Cancel).";
	}
	elsif($this->{opt}->lang eq "ko"){
		return"-> (Y = , N = ƴϿ, 0 = ).";
	}
}

#--------------------
sub room_subj{
	my $this = shift;

	if($this->{opt}->lang eq "en"){
		return "\n-> Please input subject of the room.";
	}
	elsif($this->{opt}->lang eq "ko"){
		return "\n-> ȭ  Է ּ.";
	}
}

#--------------------
sub room_limit{
	my $this = shift;

	if($this->{opt}->lang eq "en"){
		return "\n-> Please input limit of the number of guest in your room.(4 ~ 12)";
	}
	elsif($this->{opt}->lang eq "ko"){
		return "\n-> ȭ ο Է ּ.(4 ~ 12)";
	}
}

#--------------------
sub room_private{
	my $this = shift;

	if($this->{opt}->lang eq "en"){
		return "\n-> Do you want to make it private room?";
	}
	elsif($this->{opt}->lang eq "ko"){
		return "\n->  ȭ ðڽϱ?";
	}
}

#--------------------
sub room_pw{
	my $this = shift;

	if($this->{opt}->lang eq "en"){
		return "\n-> Please input password of your room.";
	}
	elsif($this->{opt}->lang eq "ko"){
		return "\n-> ȭ йȣ Է ּ.";
	}
}

#--------------------
sub pw_diff{
	my $this = shift;

	if($this->{opt}->lang eq "en"){
		return "\n-> The password you just typed is diffrent from previous one.";
	}
	elsif($this->{opt}->lang eq "ko"){
		return "\n->  Է йȣ ġ ʽϴ.";
	}
}

#--------------------
sub pw_chg{
	my $this = shift;
	my $pw = shift;

	if($this->{opt}->lang eq "en"){
		if($pw){
			return "\n-> Room password has been changed. Now this room is a private room.";
		}
		else{
			return "\n-> Room password has been deleted. Now this room is a public room.";
		}
	}
	elsif($this->{opt}->lang eq "ko"){
		if($pw){
			return "\n-> ȭ йȣ Ǿϴ.";
		}
		else{
			return "\n-> ȭ йȣ Ǿϴ.";
		}
	}
}

#--------------------
sub pw_del{
	my $this = shift;
	my $pw = shift;

	if($this->{opt}->lang eq "en"){
		return "\n-> Room password has been deleted. Now this room is a public room.";
	}
	elsif($this->{opt}->lang eq "ko"){
		return "\n-> ȭ йȣ Ǿϴ.";
	}
}

#--------------------
sub pw_wrong{
	my $this = shift;

	if($this->{opt}->lang eq "en"){
		return "\n-> The password you just typed is wrong one.";
	}
	elsif($this->{opt}->lang eq "ko"){
		return "\n-> йȣ ġ ʽϴ.";
	}
}

#--------------------
sub owner_only{
	my $this = shift;

	if($this->{opt}->lang eq "en"){
		return "\n-> You are not the owner of this room";
	}
	elsif($this->{opt}->lang eq "ko"){
		return "\n->  ƴմϴ.";
	}
}

#--------------------
sub self{
	my $this = shift;

	if($this->{opt}->lang eq "en"){
		return "\n-> You can't use this command to yourself";
	}
	elsif($this->{opt}->lang eq "ko"){
		return "\n-> ڽſԴ    Դϴ.";
	}
}

#--------------------
sub replace_owner{
	my $this = shift;
	my $name = shift;

	if($this->{opt}->lang eq "en"){
		return sprintf "\n-> Room owner has been replaced. New room owner = %s", $name;
	}
	elsif($this->{opt}->lang eq "ko"){
		return sprintf "\n->  Ǿϴ..   %sԴϴ.", $name;
	}
}

#--------------------
sub room_enter{
	my $this = shift;
	my $name = shift;

	if($this->{opt}->lang eq "en"){
		return sprintf "\n-> A guest(%s) has entered this room.", $name;
	}
	elsif($this->{opt}->lang eq "ko"){
		return sprintf "\n-> %s ȭ濡 ߽ϴ.", $name;
	}
}

#--------------------
sub room_left{
	my $this = shift;
	my $name = shift;

	if($this->{opt}->lang eq "en"){
		return sprintf "\n-> A guest(%s) has left this room.", $name;
	}
	elsif($this->{opt}->lang eq "ko"){
		return sprintf "\n-> %s ȭ ϴ.", $name;
	}
}

#--------------------
sub room_kick{
	my $this = shift;
	my $name = shift;

	if($this->{opt}->lang eq "en"){
		return sprintf "\n-> A guest(%s) has been kicked out from this room.", $name;
	}
	elsif($this->{opt}->lang eq "ko"){
		return sprintf "\n-> %s  ߽ϴ.", $name;
	}
}

#--------------------
sub pw_req{
	my $this = shift;
	my $r_no = shift;

	my $line = "";
	if($this->{opt}->lang eq "en"){
		$line = qq(
-> Room #r_no is private rooom.
-> Please input the password.);
	}
	elsif($this->{opt}->lang eq "ko"){
		$line = qq(
-> #r_no ȭ  ȭԴϴ.
-> йȣ Է ֽʽÿ.);
	}

	$line =~ s/#r_no/$r_no/;
	return $line;
}

#--------------------
sub pw_new{
	my $this = shift;

	if($this->{opt}->lang eq "en"){
		return "\n-> Please input new password of the room.";
	}
	elsif($this->{opt}->lang eq "ko"){
		return "\n->  йȣ Է ּ.";
	}
}

#--------------------
sub pw_confirm{
	my $this = shift;

	if($this->{opt}->lang eq "en"){
		return "\n-> Please retype your password to confirm.";
	}
	elsif($this->{opt}->lang eq "ko"){
		return "\n-> Ȯ  йȣ ٽ ѹ Է ּ.";
	}
}

#--------------------
sub subj_new{
	my $this = shift;

	if($this->{opt}->lang eq "en"){
		return "\n-> Please input new subject of the room.";
	}
	elsif($this->{opt}->lang eq "ko"){
		return "\n-> ȭ  Է ּ.";
	}
}

#--------------------
sub limit_new{
	my $this = shift;

	if($this->{opt}->lang eq "en"){
		 return "\n-> Please input new guest limit of the room.(4 ~ 12)";
	}
	elsif($this->{opt}->lang eq "ko"){
		return "\n-> ȭ ο Է ּ.(4 ~ 12)";
	}
}

#--------------------
sub find{
	my $this = shift;
	my $flag = shift;
	my $g_name = shift;
	my $r_no = shift;

	if($this->{opt}->lang eq "en"){
		if($flag eq "not"){
			return sprintf "\n-> %s is not here.", $g_name;
		}
		elsif($flag eq "not_room"){
			return sprintf "\n-> %s is not in room %d.", $g_name, $r_no;
		}
		elsif($flag eq "lob"){
			return sprintf "\n-> %s is in lobby.", $g_name;
		}
		elsif($flag eq "room"){
			return sprintf "\n-> %s is in room %d.", $g_name, $r_no;
		}
	}
	elsif($this->{opt}->lang eq "ko"){
		if($flag eq "not"){
			return sprintf "\n-> %s  ܿ ϴ.", $g_name;
		}
		elsif($flag eq "not_room"){
			return sprintf "\n-> %s %d ȭ濡 ϴ.", $g_name, $r_no;
		}
		elsif($flag eq "lob"){
			return sprintf "\n-> %s  κ ֽϴ.", $g_name;
		}
		elsif($flag eq "room"){
			return sprintf "\n-> %s  %d ȭ濡 ֽϴ.", $g_name, $r_no;
		}
	}
}

#--------------------
sub invite{
	my $this = shift;
	my $flag = shift;
	my $g = shift;

	if($this->{opt}->lang eq "en"){
		if($flag eq "invite"){
			return sprintf "\n-> You've got invitation from %s of room %d.", $g->name, $g->room->no;
		}
		elsif($flag eq "confirm"){
			return sprintf "\n-> Invitation has been sent to %s.", $g->name;
		}
	}
	elsif($this->{opt}->lang eq "ko"){
		if($flag eq "invite"){
			return sprintf "\n-> %s %d ȭ û ߽ϴ.", $g->name, $g->room->no;
		}
		elsif($flag eq "confirm"){
			return sprintf "\n-> %s û߽ϴ.", $g->name;
		}
	}
}

#--------------------
sub usage{
	my $this = shift;
	my $cmd = shift;

	my $line = "";
	if($this->{opt}->lang eq "en"){
		$line = "\n-> Wrong command!!";
		if($cmd eq "/J"){
			$line .= "\n-> Usage: /J {room no}, ex)/J 12, /J 23";
		}
		if($cmd eq "/F"){
			$line .= "\n-> Usage: /F {guest name}, ex)/F jiny, /F edge";
		}
		if($cmd eq "/N"){
			$line .= "\n-> Usage: /N {new name}, ex)/N jiny, /N edge";
		}
		if($cmd eq "/I"){
			$line .= "\n-> Usage: /I {guest name}, ex)/I jiny, /I edge";
		}
	}
	elsif($this->{opt}->lang eq "ko"){
		$line = "\n-> ɾ  ߸Ǿϴ!!";
		if($cmd eq "/J"){
			$line .= "\n-> : /J {ȣ}, ex)/J 12, /J 23";
		}
		if($cmd eq "/F"){
			$line .= "\n-> : /F {ȭ}, ex)/F jiny, /F edge";
		}
		if($cmd eq "/N"){
			$line .= "\n-> : /N { ȭ}, ex)/N jiny, /N edge";
		}
		if($cmd eq "/I"){
			$line .= "\n-> : /I {ȭ}, ex)/I jiny, /I edge";
		}
	}
	return $line;
}

#--------------------
sub list_info{
	my $this = shift;
	my $name = shift;

	if($this->{opt}->lang eq "en"){
		if($name eq "private"){return "Private";}
		elsif($name eq "public"){return "Public";}
		elsif($name eq "room"){return "Room";}
		elsif($name eq "participant"){return "Participant";}
		elsif($name eq "all"){return "Total number of guest";}
	}
	elsif($this->{opt}->lang eq "ko"){
		if($name eq "private"){return "";}
		elsif($name eq "public"){return "";}
		elsif($name eq "room"){return "ȭ";}
		elsif($name eq "participant"){return "";}
		elsif($name eq "all"){return "ڼ";}
	}
}

#--------------------
sub help{
	my $this = shift;
	my $flag = shift;
	my $g = shift;
	
	my $r = $g->room;
	my($r_no, $r_owner_name, $r_subj, $r_type, $r_limit);
	if($r){
		$r_no = $r->no;
		$r_owner_name = $r->owner->name;
		$r_subj = $r->subj;
		$r_type = $r->pw ? $this->list_info("private") : $this->list_info("public");
		$r_limit = $r->limit;

		if($flag ne "lob" and $g == $r->owner){
			$flag = "room_owner";
		}
	}

	my $res = "";

	if($this->{opt}->lang eq "en"){
		if($flag eq "lob"){
			$res = qq(
--------------------------------------------------------------------------------
Now you are in the lobby of the chatting server.

You can use following commands:
	/H = Help, /L = Listing rooms, /O = Open room
	, /J {room no} = Join room, /A = Listing all guests who are connecting
	, /F {guest name} = Find guest,/N {new name} = Name change
	, /CLS = Clear screen
--------------------------------------------------------------------------------);
		}
		elsif($flag eq "room"){
			$res = qq(
--------------------------------------------------------------------------------
Now you are in the room #r_no.

Room owner => #r_owner_name
Room subject => #r_subj
Room type => #r_type
Room limit => #r_limit

You can use following commands:
	/H = Help, /L = Listing rooms, /O = Open room
	, /I {guest name} = Invite someone, /A = Listing all guests in the room
	, /F {guest name} = Find guest,/N {new name} = Name change	
	, /R = Information about the room, /X = Exit room
	, /CLS = Clear screen
--------------------------------------------------------------------------------);
			$res =~ s/#r_no/$r_no/;
			$res =~ s/#r_owner_name/$r_owner_name/;
			$res =~ s/#r_subj/$r_subj/;
			$res =~ s/#r_type/$r_type/;
			$res =~ s/#r_limit/$r_limit/;
		}
		elsif($flag eq "room_owner"){
			$res = qq(
--------------------------------------------------------------------------------
Now you are in the room #r_no.

Room owner => #r_owner_name
Room subject => #r_subj
Room type => #r_type
Room limit => #r_limit

You can use following commands:
	/H = Help, /L = Listing rooms, /O = Open room
	, /I {guest name} = Invite someone, /A = Listing all guests in the room
	, /F {guest name} = Find guest,/N {new name} = Name change
	, /R = Information of the room, /X = Exit room
	, /CLS = Clear screen

Room owner commands:
	/K {guest name} = Kickout, /P = Password change
	, /S = Subject change, /LM = Limit change
	, /D = Delete password, make public room
--------------------------------------------------------------------------------);
			$res =~ s/#r_no/$r_no/;
			$res =~ s/#r_owner_name/$r_owner_name/;
			$res =~ s/#r_subj/$r_subj/;
			$res =~ s/#r_type/$r_type/;
			$res =~ s/#r_limit/$r_limit/;
		}
		return $res;
	}
	elsif($this->{opt}->lang eq "ko"){
		if($flag eq "lob"){
			$res = qq(
--------------------------------------------------------------------------------
 ġ κԴϴ.

κ񿡼  ɾ   ֽϴ.
	/H = , /L = ȭ Ʈ, /O = ȭ 
	, /J {ȭ ȣ} = ȭ , /A =  
	, /F {ȭ} =  ã,/N { ȭ} = ȭ ٲٱ
	, /CLS = ȭ 
--------------------------------------------------------------------------------);
		}
		elsif($flag eq "room"){
			$res = qq(
--------------------------------------------------------------------------------
 ġ #r_no Դϴ.

 => #r_owner_name
ȭ  => #r_subj
 = > #r_type
ο => #r_limit

  ɾ   ֽϴ.
	/H = , /L = ȭ Ʈ, /O = ȭ 
	, /I {ȭ} = ûϱ, /A =  , /F {ȭ} =  ã
	,/N { ȭ} = ȭ ٲٱ, /R = ȭ , /X = ȭ 
	, /CLS = ȭ 
--------------------------------------------------------------------------------);
			$res =~ s/#r_no/$r_no/;
			$res =~ s/#r_owner_name/$r_owner_name/;
			$res =~ s/#r_subj/$r_subj/;
			$res =~ s/#r_type/$r_type/;
			$res =~ s/#r_limit/$r_limit/;
		}
		elsif($flag eq "room_owner"){
			$res = qq(
--------------------------------------------------------------------------------
 ġ #r_no Դϴ.

 => #r_owner_name
ȭ  => #r_subj
 = > #r_type
ο => #r_limit

  ɾ   ֽϴ.
	/H = , /L = ȭ Ʈ, /O = ȭ 
	, /I {ȭ} = ûϱ, /A =  , /F {ȭ} =  ã
	,/N { ȭ} = ȭ ٲٱ , /R = ȭ , /X = ȭ 
	, /CLS = ȭ 

  ɾԴϴ.
	/K {ȭ} = , /P = йȣ , /S =  
	, /LM = ο , /D = йȣ ( ȭ )
--------------------------------------------------------------------------------);
			$res =~ s/#r_no/$r_no/;
			$res =~ s/#r_owner_name/$r_owner_name/;
			$res =~ s/#r_subj/$r_subj/;
			$res =~ s/#r_type/$r_type/;
			$res =~ s/#r_limit/$r_limit/;
		}
		return $res;
	}
}

#--------------------
sub r_limit{
	my $this = shift;

	my $line = "";
	if($this->{opt}->lang eq "en"){
		$line = qq(
-> Can't make more room.
-> Please retry later.);
	}
	elsif($this->{opt}->lang eq "ko"){
		$line = qq(
->  ̻    ϴ.
->  ڿ ٽ õϿ ּ.);
	}

	return $line;
}

#--------------------
1;
