import java.awt.*;
import java.applet.Applet;
import java.net.*;
import java.io.*;
import netscape.javascript.*;
public class Client extends Applet implements Runnable{
	private String server_addr;
	private String server_port;
	private Socket sock = null;
	private JSObject win = null;
	private Thread runner = null;
	private ByteInputStream in = null;
	private ByteOutputStream out = null;

	//-----------------------
	public void init(){
		win = JSObject.getWindow(this);
		server_addr = getParameter("server_addr");
		server_port = getParameter("server_port");
	}

	//-----------------------
	public void start(){
		try{
			sock = new Socket(server_addr, Integer.parseInt(server_port));
			in = new ByteInputStream(new DataInputStream(sock.getInputStream()));
			out = new ByteOutputStream(new DataOutputStream(sock.getOutputStream()));
		}
		catch(Exception e){
			print(e.toString());
		}

		if(runner == null){
			runner = new Thread(this);
			runner.start();
		}
	}

	//-----------------------
	public void stop(){
		if(runner != null){
			runner = null;
		}
	}

	//-----------------------
	public void disconn(){
		if(runner != null){
			runner = null;
		}
		try{
			sock.close();
		}
		catch(Exception e){}
	}

	//-----------------------
	public void talk(String line){
		if(line.equalsIgnoreCase("/cls")){
			win.eval("window.cls();");
			return;
		}

		try{
			out.write_line(line);
		}
		catch(NullPointerException npe){}
		catch(Exception e){
			print(e.toString());
		}
	}

	//-----------------------
	public void print(String line){
		win.eval("window.print(\"" + line + "\");");
	}

	//-----------------------
	public void run(){
		String line = "";
		boolean do_next = true;

		try{
			while(do_next){
				line = in.read_line();
				line = replace(line, "\n", "<br>");
				line = replace(line, " ", "&nbsp;");
				print(line);
			}
		}
		catch(Exception e){
			do_next = false;
			disconn();
		}
	}

	//-----------------------
	public static String replace(String line, String pattern, String replace){			//꽺Ʈ ġȯ
		int offset = 0;
		int toffset = 0;
		StringBuffer res = new StringBuffer();
		while((toffset = line.indexOf(pattern, offset)) > -1){
			res.append(line.substring(offset, toffset));
			res.append(replace);
			offset = toffset + pattern.length();
		}
		
		res.append(line.substring(offset));
		return res.toString();
	}
}
