import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import netscape.javascript.*;
public class Client extends Applet implements ActionListener{
	private TextArea txt_show = null;
	private TextField txt_input = null;
	private Talker talker = null;
	private Listener listener = null;
	private Socket s = null;
	private String name = "";
	private String server_addr = "";
	private String server_port = "";
	boolean is_applet = true;

	//-----------------------
	public void init(){

		if(is_applet){
			server_addr = getParameter("server_addr");
			server_port = getParameter("server_port");
		}
		else{
			server_addr = "127.0.0.1";
			server_port = "8040";
		}

		setLayout(new BorderLayout(0,0));

		Color bg = new Color(0, 51, 153);

		txt_show = new TextArea("", 0, 0, TextArea.SCROLLBARS_VERTICAL_ONLY);
		txt_show.setForeground(Color.white);
		txt_show.setBackground(bg);
		txt_show.setEditable(false);
		
		txt_input = new TextField();
		txt_input.setForeground(Color.white);
		txt_input.setBackground(bg);
		txt_input.addActionListener(this);

		add(txt_show, BorderLayout.CENTER);
		add(txt_input, BorderLayout.SOUTH);
	}

	//-----------------------
	public void start(){
		txt_input.requestFocus();
		try{s = new Socket(server_addr, Integer.parseInt(server_port));}
		catch(ConnectException ce){println("Couldn't connect..");}
		catch(Exception e){println(e.toString());}
		
		talker = new Talker(s, this);
		
		if(listener == null){
			listener = new Listener(s, this);
			listener.start();
		}
	}

	//-----------------------
	public void stop(){
		disconn();
//		if(listener != null){listener = null;}
	}

	//-----------------------
	public void actionPerformed(ActionEvent e){
		String line = txt_input.getText().trim();

		try{
			line = line.substring(0, 100);
		}
		catch(Exception se){}

		if(line.equalsIgnoreCase("/cls")){
			txt_show.setText("");
			txt_input.setText("");
			return;
		}
		talker.talk(line);
		txt_input.setText("");
	}

	//-----------------------
	public void print(String line){
		txt_show.append(line);
	}

	//-----------------------
	public void println(String line){
		txt_show.append(line + "\n");
	}

	//-----------------------
	public void disconn(){
		talker.close();
		listener.close();

		try{
			s.close();
		}
		catch(Exception e){println(e.toString());}

		if(is_applet){
		}
		else{
			System.exit(-1);
		}
	}

	//-----------------------
	public void is_applet(boolean flag){
		is_applet = flag;
	}

	//-----------------------
	public static void main(String[] args){
		Frame app = new Frame("Edge Chatting");
		app.setSize(515, 400);
		app.addWindowListener(new CloseWindowAndExit());

		Client c = new Client();
		c.is_applet(false);

		c.init();
	
		app.add(c, BorderLayout.CENTER);
		app.show();
		
		c.start();
	}
}
