import java.net.*;
import java.io.*;
class Listener extends Thread{
	private Client client = null;
	private Socket s = null;
	private ByteInputStream in = null;

	//-----------------------
	public Listener(Socket _s, Client _client){
		s = _s;
		client = _client;

		try{
			in = new ByteInputStream(new DataInputStream(s.getInputStream()));
		}
		catch(Exception e){
			client.println(e.toString());
			client.disconn();
		}
	}

	//-----------------------
	public void run(){
		boolean do_next = true;
		String line = "";

		try{
			while(do_next){
				client.print(in.read_line());
			}
		}
		catch(EOFException eof){
			client.println("\nConnection closed....");
			client.disconn();
		}
		catch(Exception e){
			client.println(e.toString());
			do_next = false;
			client.disconn();
		}
	}

	//-----------------------
	public void close(){
		try{
			if(in != null){in.close();}
		}
		catch(Exception ex){client.println(ex.toString());}
	}
}
